from .style import parse_font

def parse_richtext(text, workbook):
    texts = []
    if not text.formatted:
        return text.content
    for block in text.r:
        if not block.t:
            continue
        text_run = {'tx': block.t}
        if block.rPr:
            font_config = parse_font(block.rPr, workbook)
            if font_config:
                text_run['s'] = font_config
        texts.append(text_run)
    return {'t': 'r', 'v': texts} if texts else None
