<?php

namespace PhpOffice\PhpPresentation\Writer\ProseMirror;

use PhpOffice\PhpPresentation\Shape\RichText;

class Holder extends FloatingObject
{
    public function __construct($slide, $container)
    {
        parent::__construct($slide, $container);
        $this->setAttr('type_id', '0');
    }

    protected function setVerticalAlign($item)
    {
        $phpAlignment = $this->phpShape->getAlignment();
        if (!is_null($phpAlignment)) {
            switch ($phpAlignment->getVertical()) {
                case 'ctr':
                    $alignment = 0;
                    break;
                case 'b':
                    $alignment = 1;
                    break;
                case 't':
                    $alignment = -1;
                default:
                    break;
            }
            if (isset($alignment)) {
                $item->setAttr('vertical_align', $alignment);
            }
        }
    }

    protected function getHorizontalAlign($align)
    {
        switch ($align) {
            case 'ctr':
                return 'center';
            case 'l':
                return 'left';
            case 'r':
                return 'right';
            case 'just':
                return 'justify';
            default:
                return '';
        }
    }

    protected function setTextBlockPadding($textBlock)
    {
        $padding = new \stdClass();
        if (RichText::INSET_NONE !== $this->phpShape->getInsetTop()) {
            $padding->top = $this->phpShape->getInsetTop();
        }
        if (RichText::INSET_NONE !== $this->phpShape->getInsetRight()) {
            $padding->right = $this->phpShape->getInsetRight();
        }
        if (RichText::INSET_NONE !== $this->phpShape->getInsetBottom()) {
            $padding->bottom = $this->phpShape->getInsetBottom();
        }
        if (RichText::INSET_NONE !== $this->phpShape->getInsetLeft()) {
            $padding->left = $this->phpShape->getInsetLeft();
        }
        $textBlock->setAttr('padding', $padding);
    }
}

?>
