"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TextAction=void 0;var e=require("./base_action");var t=require("synoffice-model");var i=require("synoffice-core-utils");const l={stopAtSeparator:true};const n=i.Obj.createEnum("END_OF_LINE","NODE_HARD_BREAK","NODE_INLINE","TEXT_SPACE","TEXT_SYMBOL","TEXT_WORD","TEXT_SINGLE");const s=["font_family","font_size","strong","em","underline","color","background_color"];class r{static isNodeType(e){return e===n.NODE_HARD_BREAK||e===n.NODE_INLINE}static isTextType(e){switch(e){case n.TEXT_SPACE:case n.TEXT_SYMBOL:case n.TEXT_WORD:case n.TEXT_SINGLE:return true;default:return false}}static isSingleType(e){return e===n.END_OF_LINE||e===n.TEXT_SINGLE}static textType(e){switch((0,i.getCharCodeType)(e)){case i.CharEnum.SPACE:return n.TEXT_SPACE;case i.CharEnum.SYMBOL:return n.TEXT_SYMBOL;case i.CharEnum.WORD:return n.TEXT_WORD;case i.CharEnum.SINGLE:return n.TEXT_SINGLE;default:throw new Error("Unknown CharEnum.")}}static nodeType(e){if(e.isText){throw new Error("Given node is text.")}else if(e.type.isBR){return n.NODE_HARD_BREAK}else{return n.NODE_INLINE}}static charType(e,t){if(!e){return n.END_OF_LINE}else{if(e.isText){return this.textType(e.text.charCodeAt(t))}else{return this.nodeType(e)}}}}class o extends e.BaseAction{static checkSelection(e,t){if(!e.isMultiTextSelection||e.isMultiHolderTextSelection){return null}if(t){const i=e.selection();if(t.empty&&!i.empty){return null}if(t.non_empty&&i.empty){return null}}return e}static ensureSelection(e,i){if(!this.checkSelection(e)){let i;if(e.isMultiInlineNodeSelection&&!e.isMultiPageNumberSelection){const l=e.selection();i=t.TextSelection.createResolved(l.$from,l.$to,true)}else if(e.isMultiCellSelection){const l=e.headSelection();i=t.Selection.findRange(l.$from,l.$to)}else if(e.isMultiFloatingSelection){if(e.single){const l=e.selection(),n=l.node;if(n.type.isBox){if(n.type.isTableBox){i=t.Selection.findFrom(l.$from,1,true)}else{const e=n.getTextBlockData();if(e){const n=l.$from;i=t.TextSelection.createResolved(n.extend(e.offset+1),n.extend(e.offset+e.node.nodeSize-1),true)}}}}}e=i?i.toMultiSelection():null}return e&&this.checkSelection(e,i)}static ensureSingleSelection(e,t){e=this.ensureSelection(e,t);return e&&e.selection()}static ensureInsertSingleSelection(e,t){const i=o.ensureSingleSelection(e,t);return i&&i.collapse()}static ensureSelectionOld(e,i){if(e.isMultiCellSelection){e=t.TextSelection.createResolved(e.$anchor).toMultiSelection()}return e.isSpecial||!i&&e.isMultiPageNumberSelection?null:e}static ensureTextSelection(e){return e.isMultiTextSelection||e.isMultiInlineNodeSelection?e:null}static ensureSingleSelectionOld(e,t){e=this.ensureSelectionOld(e,t);return e&&e.selection()}static ensureSingleTextSelection(e){e=this.ensureTextSelection(e);return e&&e.selection()}static ensureSameEditorSingleSelection(e,i,l){if(this.sameEditor(e,i)){return this.ensureSingleSelectionOld(e,l)}else{let e=i.findDepth("contentEditable");return isNaN(e)?null:t.Selection.findFrom(i.shrink(e-1),1,true)}}static ensureSelectionBias(e,t){if(!e.isSpecial){if(e.isMultiTextSelection){return e.bias}else if(e.isMultiNodeSelection){let i=e.node();return this.ensureDirection(t)*(i.type.isInline?-1:1)}}return 1}static ensureTextResolvedPos(e,i){return t.TextSelection.checkAvailable(e)?e:t.Selection.findNear(e,this.ensureDirection(i),true).$from}static resolveAnchor(e,t,i){let l;if(e.isTextSelection){l=e.$anchor}else{if(i){t=this.ensureDirection(t);l=this.ensureTextResolvedPos(t<0?e.$to:e.$from,-t)}else{l=e.$from}}return l}static resolveHead(e,t,i){let l;if(e.isTextSelection){l=e.$head}else{if(i){t=this.ensureDirection(t);l=this.ensureTextResolvedPos(t<0?e.$from:e.$to,t)}else{l=e.$from}}return l}static resolveSide(e,t,i){t=this.ensureDirection(t);let l=t<0?e.$from:e.$to;if(i){l=this.ensureTextResolvedPos(l,t)}return l}static resolveDirection(e,t,i){return t<e.from&&i<=e.to||t<=e.from&&i<e.to?-1:1}static isBounded(e,t){return e.pos>=t.from&&e.pos<=t.to}static sameEditor(e,t){return e.insideEditor&&e.$editor&&this.insideNode(t.pos,e.$editor)}static insideNode(e,i){if(i instanceof t.ResolvedPos){return e>=i.pos&&e<i.pos+i.self.nodeSize}else{return e>=i.pos&&e<i.pos+i.node.nodeSize}}static maybeMultiCellSelection(e,i,l){return i&&t.MultiCellSelection.createSelected([e],true,l)||e.toMultiSelection(l)}static acrossTableCell(e,t){return e.findNode("isTableCell")!=t.findNode("isTableCell")}static charInfo(e,i){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}i=this.ensureDirection(i);let l,n,s;if(e.atNodeBoundary){l=e.index()+(i>0?0:-1);n=e.parent.maybeChild(l);s=n&&(i>0?0:n.nodeSize-1)}else{l=e.index();n=e.parent.maybeChild(l);s=n&&e.innerOffset+(i>0?0:-1)}return{index:l,child:n,offset:s,type:r.charType(n,s)}}static findChar(e,i,l,s){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}i=this.ensureDirection(i);let{index:o,child:c,offset:a,type:f}=this.charInfo(e,i);if(l!=null&&l!==f){return{$pos:e,type:l}}l=f;if(l===n.END_OF_LINE){if(c){return{$pos:e,type:l}}else{let n=t.Selection.findFrom(e.shrink(e.depth-1,i>0),i,true);if(n&&s&&s.stopAtSeparator&&this.acrossTableCell(e,n.$from)){n=null}return{$pos:n?n.$from:e,type:l}}}else{let t=e.pos,n=e.parent;for(c=n.maybeChild(o);c;o+=i,c=n.maybeChild(o)){if(r.isNodeType(l)){if(c.isText||r.nodeType(c)!==l){break}t+=c.nodeSize*i}else{if(!c.isText){break}if(a==null){a=i>0?0:c.nodeSize-1}let e,n,s,o=c.text;for(e=a,n=o.charCodeAt(e);!isNaN(n);e+=i,n=o.charCodeAt(e)){if(r.textType(n)!==l){s=true;break}else{if(r.isSingleType(l)){s=true;e+=i;break}}}t+=e-a;if(s){break}else{a=null}}}return{$pos:e.doc.resolve(t),type:l}}}static findWord(e,i,l){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}i=this.ensureDirection(i,true);if(i>0){e=this.findChar(e,i,null,l).$pos;e=this.findChar(e,i,n.TEXT_SPACE,l).$pos}else{e=this.findChar(e,i,n.TEXT_SPACE,l).$pos;e=this.findChar(e,i,null,l).$pos}return e}static atWordBoundary(e){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}let i=this.charInfo(e,1).type;if(r.isSingleType(i)){return true}else if(i===n.TEXT_SPACE){return false}return this.charInfo(e,-1).type!==i}static extendWord(e,i,l,s){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}if(!l&&this.atWordBoundary(e)){return{$from:e,$to:e}}i=this.ensureDirection(i,true);let o=e,c=e;let a=this.findChar(e,1,null,s);if(a.type===n.TEXT_SPACE){if(i<=0){o=this.findChar(o,-1,n.TEXT_SPACE,s).$pos;o=this.findChar(o,-1,null,s).$pos}if(i>=0){c=a.$pos}}else{if(i<=0&&!r.isSingleType(a.type)){o=this.findChar(o,-1,a.type,s).$pos}if(i>=0){c=this.findChar(a.$pos,1,n.TEXT_SPACE,s).$pos}}return{$from:o,$to:c}}static atTextblockBoundary(e){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}return e.parentOffset===0}static extendTextblock(e,i,l,n){if(!t.TextSelection.checkAvailable(e)){throw new RangeError("Given `$pos` is not inside textblock.")}if(!l&&this.atTextblockBoundary(e)){return{$from:e,$to:e}}i=this.ensureDirection(i,true);let s=e.doc,r=e,o=e;if(i<=0){r=s.resolve(r.start())}if(i>=0){o=this.findBlock(e,1);if(!o||o.self.type.isTextblock||n&&n.stopAtSeparator&&this.acrossTableCell(e,o)){o=s.resolve(e.end())}else{o=o.extendByIndexArr([0])}}return{$from:r,$to:o}}static findBlock(e,i,l){const n=e.findData("isBlock");if(!n){return null}i=this.ensureDirection(i);let s=t.Selection.findFrom(e.shrink(n.depth-1,i>0),i);if(!s){return null}let r=s.$from;const o=r.findData("isTableCell");if(o){const n=e.findData("isTableCell");if(n){if(n.node!==o.node){try{let l=n.depth-2,o=e.node(l),c=e.index(l),a=e.index(l+1);let f=o.getSiblingDisplayCellIndex(c,a,i,0);if(f){r=e.shrink(l-1).extendByIndexArr([f.row,f.col+(i>0?0:1)])}else{let t=e.doc.type.schema;if(t.isDocument){r=e.shrink(l-1,i>0)}else{f=o.getDisplayCellIndex(c,a);f=o.getDisplayCellIndex(i>0?0:o.getRowSize()-1,f.col+i);r=f&&e.shrink(l-1).extendByIndexArr([f.row,f.col+(i>0?0:1)])}}s=r&&t.Selection.findFrom(r,i);r=s&&s.$from}catch(e){console.log("Finding table cell block failed.")}}}else{const e=l&&l.cursor_x;if(e!=null){const l=o.depth-1;let n;r.node(l).forEach(function(t,i,l){n=l;const s=t.state.text_rect_info;if(e<s.left+s.width){return true}},this,true);if(r.index(l)!==n){s=t.Selection.findFrom(r.shrink(l-1).extendByIndexArr([n+(i>0?0:1)]),i);r=s&&s.$from}}}}return r&&r.shrink(r.findDepth("isBlock")-1)}static selectTextHorizontally(e,i,l){let n=this.ensureSingleSelectionOld(e);if(!n){return null}i=this.ensureDirection(i);let s=n.$from.doc,r,o;if(l){let e=this.resolveHead(n,i,true);let l=e.pos;if(this.isBounded(e,n)){if(i>0?e.pos===e.end():e.pos===e.start()){let n=t.Selection.findFrom(e.shrink(e.depth-1,i>0),i,true);if(n){o=this.acrossTableCell(e,n.$from);l=n.from}else{l=e.pos}}else{l=e.pos+i}}r=t.TextSelection.create(s,this.resolveAnchor(n,i,true).pos,l)}else{let e=this.resolveSide(n,i);if(n.empty){if(i>0?e.pos===e.end():e.pos===e.start()){r=t.Selection.findNear(e.shrink(e.depth-1,i>0),i)}else{if(e.atNodeBoundary){let l=e.parent.maybeChild(e.index()-(i>0?0:1));if(l&&!l.isText&&l.type.selectable){r=t.NodeSelection.create(s,e.pos-(i>0?0:l.nodeSize))}}if(!r){r=t.TextSelection.create(s,e.pos+i)}}}else{if(n.isNodeSelection&&!n.node.type.isInline){r=t.Selection.findNear(e,i)}else{r=t.TextSelection.createResolved(e)}}}return this.maybeMultiCellSelection(r,o,{bias:-i})}static selectWordHorizontally(e,i,l){let n=this.ensureSingleSelectionOld(e);if(!n){return null}i=this.ensureDirection(i);let s=this.resolveHead(n,i,true),r;if(this.isBounded(s,n)){let e=this.findWord(s,i);if(l&&(r=this.acrossTableCell(s,e))){s=s.doc.resolve(i>0?s.end():s.start())}else{s=e}}return this.maybeMultiCellSelection(t.TextSelection.createResolved(l?this.resolveAnchor(n,i,true):s,s),r,{bias:-i})}static selectLineVertically(e,i,l,n){let s=this.ensureSingleSelectionOld(e);if(!s){return null}i=this.ensureDirection(i);let r=this.ensureSelectionBias(e,i);let o=this.resolveHead(s,i);let c=t.TextSelection.checkAvailable(o);const a=n&&n.DOMNode;const f=n&&n.cursor_x||0;let u,d,h;if(a&&c){const e=o.parent.dom;const t=a.fly(e).elementInfoAtOffset(o.parentOffset,{bias:r,bound:true});h=a.fly(t.dom).getData("line_index");if(i>0?h<a.fly(e).getData("line_count")-1:h>0){d=o;h+=i}}if(!u&&!d){d=this.findBlock(o,i,{cursor_x:f});if(d){let e=d.self;if(e.type.isTextblock){if(a){h=i>0?0:a.fly(e.dom).getData("line_count")-1}}else{u=t.NodeSelection.create(d.doc,d.pos)}}else{return c?this.selectLineSidely(e,i,l,n):null}}if(!u){let e=d.findData("isTextblock"),c;if(n&&a&&n.pm){const t=a.fly(e.node.dom).elementInfoAtIndex(h);const i=n.pm.dompos.inlineOffsetAtCoordsX(d,t.dom,f).offset;c=e.pos+1+i;r=i===t.offset+t.size?-1:1}else{c=e.pos+1+(i>0?e.node.nodeSize-2:0);r=-i}u=t.TextSelection.create(o.doc,l?this.resolveAnchor(s,i,true).pos:c,c)}return u.toMultiSelection({bias:r})}static selectBlockVertically(e,i,l){let n=this.ensureSingleSelectionOld(e);if(!n){return null}i=this.ensureDirection(i);let s=this.resolveHead(n,i);let r=t.TextSelection.checkAvailable(s);if(r&&i<0&&s.parentOffset!==0){return this.selectTextblockSidely(e,i,l)}let o=this.findBlock(s,i),c;if(o){if(o.self.type.isTextblock){let e=o.pos+1;c=t.TextSelection.create(o.doc,l?this.resolveAnchor(n,i,true):e,e)}else{c=t.NodeSelection.create(o.doc,o.pos)}}else{return r?this.selectTextblockSidely(e,i,l):null}return c.toMultiSelection({bias:this.ensureSelectionBias(e,i)})}static selectLineSidely(e,i,l,n){let s=this.ensureSingleSelectionOld(e);if(!s){return null}i=this.ensureDirection(i,true);let r=this.resolveHead(s,i);if(!t.TextSelection.checkAvailable(r)){return null}let o,c,a,f=n&&n.DOMNode;if(f){const t=f.fly(r.parent.dom).elementInfoAtOffset(r.parentOffset,{bias:this.ensureSelectionBias(e,i),bound:true});if(i<=0){a=o=r.start()+t.offset}if(i>=0){const e=t.size;let i=t.offset+e;if(e>0&&r.parent.nodeAt(i-1).type.isBR){--i}a=c=r.start()+i}}else{if(i<=0){a=o=r.start()}if(i>=0){a=c=r.end()}}let u;if(i===0){u=t.TextSelection.create(r.doc,o,c)}else{u=t.TextSelection.create(r.doc,l?this.resolveAnchor(s,i,true).pos:a,a)}return u.toMultiSelection({bias:-i})}static selectTextblockSidely(e,t,i){return this.selectLineSidely(e,t,i)}static selectEditorSidely(e,i,l){let n=this.ensureSingleSelectionOld(e);if(!n){return null}i=this.ensureDirection(i,true);let s,r,o,c=n.$from,a=c.doc;let f=c.findDepth("contentEditable");if(isNaN(f)){if(i<=0){o=s=t.Selection.findAtStart(a,true).$from}if(i>=0){o=r=t.Selection.findAtEnd(a,true).$to}}else{if(i<=0){o=s=t.Selection.findFrom(c.shrink(f-1),1,true).$from}if(i>=0){o=r=t.Selection.findFrom(c.shrink(f-1,true),-1,true).$to}}let u;if(i===0){u=t.TextSelection.createResolved(s,r)}else{u=t.TextSelection.createResolved(l?this.resolveAnchor(n,i,true):o,o)}return u.toMultiSelection({bias:-i})}static selectCollapsed(e){let i=this.ensureSingleSelectionOld(e);if(!i){return null}return t.Selection.findNear(i.$to,1,true).toMultiSelection({bias:-1})}static selectTextClick(e,i,l,n,s){if(!t.TextSelection.checkAvailable(i)){return null}let r;let o=i.pos,c=o;if(s){let t=this.ensureSameEditorSingleSelection(e,i);if(!t){return null}c=this.resolveAnchor(t,this.resolveDirection(t,o,o),true).pos}else{if(l){let e=i.self;if(e&&e.type.selectable){r=t.NodeSelection.create(i.doc,o)}}}if(!r){r=t.TextSelection.create(i.doc,c,o)}return r.toMultiSelection({bias:n})}static selectWordClick(e,i,n,s,r){if(!t.TextSelection.checkAvailable(i)){return null}let{$from:o,$to:c}=this.extendWord(i,0,true);let a=this.acrossTableCell(o,c);if(a){if(this.acrossTableCell(o,i)){o=i.doc.resolve(i.start())}else{c=i.doc.resolve(i.end())}}let f=o,u=c;if(r){let t=this.ensureSameEditorSingleSelection(e,o);if(!t){return null}let i=this.resolveAnchor(t,this.resolveDirection(t,o.pos,c.pos),true);if(i.pos<=o.pos){f=i.pos===o.pos?o:this.extendWord(i,-1,false,l).$from;u=c}else if(i.pos>=c.pos){f=i.pos===c.pos?c:this.extendWord(i,1,false,l).$to;u=o}}return this.maybeMultiCellSelection(t.TextSelection.createResolved(f,u),a,{bias:s})}static selectTextblockClick(e,i,n,s,r){if(!t.TextSelection.checkAvailable(i)){return null}let{$from:o,$to:c}=this.extendTextblock(i,0,true);let a=this.acrossTableCell(o,c);if(a){if(this.acrossTableCell(o,i)){o=i.doc.resolve(i.start())}else{c=i.doc.resolve(i.end())}}let f=o,u=c;if(r){let t=this.ensureSameEditorSingleSelection(e,o);if(!t){return null}let i=this.resolveAnchor(t,this.resolveDirection(t,o.pos,c.pos),true);if(i.pos<=o.pos){f=i.pos===o.pos?o:this.extendTextblock(i,-1,false,l).$from;u=c}else if(i.pos>=c.pos){f=i.pos===c.pos?c:this.extendTextblock(i,1,false,l).$to;u=o}}return this.maybeMultiCellSelection(t.TextSelection.createResolved(f,u),a,{bias:s})}static selectHeadingId(e,i,l){const n=e.doc;let s=false;n.descendants(function(e,t){if(e.type.isHeading&&e.getAttrValue("synohead")===i){s=t;return true}return e.type.isTextblock?false:undefined});if(s===false){return null}return t.MultiTextSelection.create2(n,[s+1],[null],true)}static addTextMark(e,t,i){let l=this.ensureSingleTextSelection(t);if(!l){return false}e.addMark(l.from,l.to,i)}static removeTextMark(e,t,i){let l=this.ensureSingleTextSelection(t);if(!l){return false}e.removeMark(l.from,l.to,i)}static clearTextFormat(e,t,l=i.Define.emptyObject){let n=this.removeTextMark(e,t);if(n===false){return n}if(t.$from().doc.type.isDocument){const t=l.heading_style_map;if(t){n=this.applyCustomStyle(e,t,Object.assign(Object.create(null),l,{partial:true,skip_reset:true}))}}return n}static _insertBlock(e,t,i){if(!t.type.isBlock){return false}const l=this.ensureInsertSingleSelection(e.multiSelection);if(!l){return false}e.insert(l.from,t);return true}static insertBlock(e,t,i){return this.delete(e,i)&&this._insertBlock(e,t,i)}static delete(e,t){const i=this.ensureSingleSelection(e.multiSelection);if(!i){return false}if(i.empty){return true}const{$from:l,$to:n}=i.extendRange();e.delete(l.pos,n.pos);return true}static getTextblockStyle(e,t){if(t.type.isHeading){return e[`h${t.attrs.level}`]}else{return e["p"]}}static applyCustomStyle(e,t,l=i.Define.emptyObject){const n=this.ensureSingleSelection(e.multiSelection);if(!n){return false}const r=[];n.nodesInside(function(e,i,l,n){if(e.type.isTextblock&&!e.type.isPageNumberBlock){r.push({node:e,pos:i,style:this.getTextblockStyle(t,e)});return false}},this);const{partial:o,skip_reset:c}=l;const{from:a,to:f}=n;for(let t=r.length-1;t>=0;--t){const{node:i,pos:l,style:n}=r[t];const u=l+1,d=l+i.nodeSize-1;if(!o||u>=a&&d<=f){e.setNodeAttrs(l,n.attrs)}const h=n.marks;if(h.length){for(let t=h.length-1;t>=0;--t){e.addMark(u,d,h[t])}}else if(!c){for(let t=s.length-1;t>=0;--t){const l=i.type.schema.marks[s[t]];if(l){e.removeMark(u,d,l)}}}}return true}}exports.TextAction=o;